/**
 * \brief initialisiert I2C-Hardware
 */
extern void	i2c_init(void);

/**
 * \brief sendet Start-Bedingung I2C-Bus
 */
extern void	i2c_start(void);

/**
 * \brief sendet Stop-Bedingung I2C-Bus
 */
extern void	i2c_stop(void);

/**
 * \brief sendet 1 Byte zum I2C-Bus
 * \param tx_byte das zu sendende Byte
 * \return 0xFF: kein ACK empfangen; 0: ACK empfangen
 */
extern uint8_t	i2c_write(uint8_t tx_byte);

/**
 * \brief empfängt 1 Byte vom I2C-Bus
 * \param ack 1: kein ACK senden, 0: ACK senden
 * \return empfangenes Byte
 */
extern uint8_t	i2c_read(uint8_t ack);

