#include <avr/io.h>

.global uart_init
.func uart_init
uart_init:
	out 	UBRRL-__SFR_OFFSET, r24
	out 	UBRRH-__SFR_OFFSET, r25
	; Enable receiver and transmitter
	sbi	UCSRA-__SFR_OFFSET,U2X	;doppelte Baudrate
	ldi 	r24, (1<<RXEN)|(1<<TXEN)
	out 	UCSRB-__SFR_OFFSET,r24
	; Set frame format: 8data, 1stop bit
	ldi 	r24, (1<<URSEL)|(0<<USBS)|(3<<UCSZ0)
	out 	UCSRC-__SFR_OFFSET,r24
	ret
.endfunc

.global uart_tx
.func uart_tx
uart_tx:
	; Wait for empty transmit buffer
	sbis 	UCSRA-__SFR_OFFSET,UDRE
	rjmp 	uart_tx
	; Put data (r16) into buffer, sends the data
	out	UDR-__SFR_OFFSET,r24
	ret
.endfunc

.global uart_rx
.func uart_rx
uart_rx:
	; Wait for data to be received
	sbis 	UCSRA-__SFR_OFFSET, RXC
	rjmp 	uart_rx
	; Get and return received data from buffer
	in	r24, UDR-__SFR_OFFSET
	ret
.endfunc